package com.redhat.oskutka;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;

import org.apache.commons.httpclient.HttpClient;
import org.apache.xmlrpc.XmlRpcException;
import org.apache.xmlrpc.client.XmlRpcClient;
import org.apache.xmlrpc.client.XmlRpcClientConfigImpl;
import org.apache.xmlrpc.client.XmlRpcCommonsTransportFactory;

public class App 
{
	@SuppressWarnings("unchecked")
	public static void main( String[] args )
	{
		try {
			XmlRpcClient rpcClient = new XmlRpcClient();
			XmlRpcClientConfigImpl config = new XmlRpcClientConfigImpl();
			config.setServerURL(new URL("http://bugzilla.redhat.com/xmlrpc.cgi"));
			HttpClient httpClient = new HttpClient();

			XmlRpcCommonsTransportFactory factory = new XmlRpcCommonsTransportFactory(rpcClient);

			factory.setHttpClient(httpClient);

			rpcClient.setTransportFactory(factory);

			rpcClient.setConfig(config);

			Map<String, String> searchParams = new HashMap<String, String>();
			searchParams.put("reporter", "oskutka@redhat.com");
			searchParams.put("creation_time", "2022-07-01T00:00:00+0000");
			//searchParams.put("creation_ts", "2022-07-01T00:00:00+0000");

			Map<String, Object> searchResult = (Map<String, Object>) rpcClient.execute("Bug.search", new Object[]{searchParams});
			System.err.println ("sql used: " + searchResult.get("sql"));
			Object[] bugs = (Object[]) searchResult.get("bugs");
			System.err.println ("Found " + bugs.length + " bugs:");
			if (bugs.length > 0) {
				System.err.println("This is a bug. I should have found zero bugs, because creation_time was set to the future. ");
			}
			for (Object bugO: bugs) {
				Map<String, Object> bugMap = (Map<String, Object>) bugO;
				System.out.println(bugMap.get("bug_id") + ": " + bugMap.get("short_desc"));
			}
		} catch (XmlRpcException e) {
			e.printStackTrace();
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}
	}
}
